using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.Threading;

using Xilium.CefGlue;
using Xilium.CefGlue.Platform;

namespace Test
{
    class CrashRendererProcessResourceHandler : CefResourceHandler
    {
    class CookiesNotWorkingResourceHandler : CefResourceHandler
    {
        MemoryStream ms;

        protected override void Cancel()
        {
            throw new NotImplementedException();
        }

        protected override bool CanGetCookie(CefCookie cookie)
        {
            return true;
        }

        protected override bool CanSetCookie(CefCookie cookie)
        {
            return true;
        }

        protected override bool ProcessRequest(CefRequest request, CefCallback callback)
        {
            this.ms = new MemoryStream();

            // Init the stream writer
            StreamWriter sw = new StreamWriter(this.ms);

            // Write the error page
            sw.Write("<!DOCTYPE html>\r\n");
            sw.Write("<html>\r\n");
            sw.Write("    <body>\r\n");
            sw.Write("        <h1>{0}</h1>\r\n", request.Url);
            sw.Write("        \r\n");
            sw.Write("        <div>\r\n");
            sw.Write("        COOKIES: <span id=\"cookies\"></span>\r\n");
            sw.Write("        </div>\r\n");
            sw.Write("        <iframe src=\"https://www.google.com\" width=\"500\" height=\"300\"></iframe>\r\n");
            sw.Write("        <iframe src=\"http://www.microsoft.com\" width=\"500\" height=\"300\"></iframe>\r\n");
            sw.Write("        \r\n");
            sw.Write("        <script type=\"text/javascript\">\r\n");
            sw.Write("            window.onload = function(e) { document.getElementById('cookies').innerHTML = document.cookie; };\r\n");
            sw.Write("        </script>\r\n");
            sw.Write("    </body>\r\n");
            sw.Write("</html>\r\n");
            sw.Flush();

            // Reset the position
            ms.Position = 0;

            callback.Continue();

            return true;
        }

        protected override void GetResponseHeaders(CefResponse response, out long responseLength, out string redirectUrl)
        {
            NameValueCollection responseHeaders = new NameValueCollection();

            responseHeaders.Add("Content-Type", "text/html; charset=utf-8");
            responseHeaders.Add("Set-Cookie", "thisis=atest; Path=/");

            response.Status = 200;
            response.StatusText = "OK";
            response.MimeType = "text/html";
            response.SetHeaderMap(responseHeaders);

            responseLength = this.ms.Length;
            redirectUrl = null;
        }

        protected override bool ReadResponse(Stream response, int bytesToRead, out int bytesRead, CefCallback callback)
        {
            // Check if datas are available
            if (bytesToRead == 0 || this.ms == null || this.ms.Position >= this.ms.Length)
            {
                bytesRead = 0;
                return false;
            }
            else
            {
                byte[] buffer = new byte[bytesToRead];

                // Read from the buffer
                bytesRead = this.ms.Read(buffer, 0, buffer.Length);

                // Write the buffer
                response.Write(buffer, 0, bytesRead);

                // Check if the end of read stream have been reached
                if (this.ms.Length == this.ms.Position)
                {
                    this.ms.Close();
                }

                return true;
            }
        }
    }
}
