﻿using Cef3Test.Handlers;
using Xilium.CefGlue;

namespace Cef3Test.Browser
{
	internal sealed class WebClient : CefClient
	{
		private readonly WebBrowserCore _core;
		private readonly CefLifeSpanHandler _lifeSpanHandler;
		private readonly CefLoadHandler _loadHandler;

		public WebClient(WebBrowserCore core)
		{
			_core = core;
			_lifeSpanHandler = new BrowserLifeSpanHandler(_core);
			_loadHandler = new LoadHandler(_core);
		}

		protected override CefLifeSpanHandler GetLifeSpanHandler()
		{
			return _lifeSpanHandler;
		}

		protected override CefLoadHandler GetLoadHandler()
		{
			return _loadHandler;
		}
	}
}
