﻿using System;
using System.Diagnostics;
using System.Windows.Forms;
using Cef3Test.Browser;

namespace Cef3Test
{
	public partial class Form1 : Form
	{
		private CefPlatform _platform;
		private CefWebBrowser browser;
		private int index = -1;

		public Form1(CefPlatform platform)
		{
			_platform = platform;

			InitializeComponent();

			browser = new CefWebBrowser {Dock = DockStyle.Fill};
			browser.CreateControl();
			panel2.Controls.Add(browser);

			browser.Loaded += BrowserLoaded;
		}

		void BrowserLoaded(object sender, EventArgs e)
		{
			Debug.WriteLine(string.Format("Loaded : {0}", browser.BrowserCore.Url));
		}

		private void button1_Click(object sender, EventArgs e)
		{
			browser.BrowserCore.CefBrowser.GetMainFrame().LoadUrl(textBox1.Text);
		}

		protected override void OnClosed(EventArgs e)
		{
			base.OnClosed(e);

			_platform.Quit();
		}
	}
}
