﻿using System;
using Xilium.CefGlue;

namespace Cef3Test.Handlers
{
	public class RenderProcessHandler : CefRenderProcessHandler
	{
		protected override void OnContextCreated(CefBrowser browser, CefFrame frame, CefV8Context context)
		{
			// Retrieve the 'window' object.
			var window = context.GetGlobal();

			CefV8Handler handler = new HelloV8Handler();

			CefV8Value obj = CefV8Value.CreateObject(null);
			CefV8Value func = CefV8Value.CreateFunction("world", handler);

			obj.SetValue("world", func, CefV8PropertyAttribute.None);
			obj.SetValue("str", CefV8Value.CreateString("hello world!"), CefV8PropertyAttribute.None);
			obj.SetValue("bool", CefV8Value.CreateBool(true), CefV8PropertyAttribute.None);
			obj.SetValue("int", CefV8Value.CreateInt(1234), CefV8PropertyAttribute.None);
			obj.SetValue("double", CefV8Value.CreateDouble(123.456), CefV8PropertyAttribute.None);
			obj.SetValue("date", CefV8Value.CreateDate(DateTime.Now), CefV8PropertyAttribute.None);
			
			window.SetValue("hello", obj, CefV8PropertyAttribute.None);
			
			base.OnContextCreated(browser, frame, context);
		}
	}
}
